// perf2.cpp : Defines the entry point for the console application.
//


// Performance Counters.cpp : ܼ  α׷   մϴ.
//

#include <stdafx.h>
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <tchar.h>
TCHAR *pStrbuf;
TCHAR **pCounterNames;
TCHAR **pCounterIDs;
DWORD dwTracks[5000];
DWORD dwTotalTrack;

__int64 freq;
int GetNumOfCounters()
{
	HKEY hKeyPerflib;
	DWORD dwCounters;
	DWORD dwSize= sizeof(dwCounters);

	RegOpenKeyEx( HKEY_LOCAL_MACHINE, 
		TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Perflib"),
		0,
		KEY_READ,
		&hKeyPerflib);

	RegQueryValueEx( hKeyPerflib,
		TEXT("Last Counter"),
		NULL,
		NULL,
		(LPBYTE)&dwCounters,
		&dwSize);

	RegCloseKey( hKeyPerflib);
	return dwCounters;
}

PPERF_OBJECT_TYPE FirstObject( PPERF_DATA_BLOCK PerfData )
{
	return ( (PPERF_OBJECT_TYPE)( (PBYTE)PerfData + PerfData->HeaderLength) );
}

PPERF_OBJECT_TYPE NextObject( PPERF_OBJECT_TYPE PerfObj )
{
	return ( (PPERF_OBJECT_TYPE)( (PBYTE)PerfObj + PerfObj->TotalByteLength) );
}

PPERF_INSTANCE_DEFINITION FirstInstance( PPERF_OBJECT_TYPE PerfObj )
{
	return ( (PPERF_INSTANCE_DEFINITION)(PBYTE)PerfObj + 
		PerfObj->DefinitionLength );
}

PPERF_INSTANCE_DEFINITION NextInstance( PPERF_INSTANCE_DEFINITION PerfInst )
{
	PPERF_COUNTER_BLOCK PerfCntrBlk;
	PerfCntrBlk= (PPERF_COUNTER_BLOCK)( (PBYTE)PerfCntrBlk +
		PerfCntrBlk->ByteLength);

	return ( (PPERF_INSTANCE_DEFINITION)( (PBYTE)PerfCntrBlk +
		PerfCntrBlk->ByteLength) );
}

PPERF_COUNTER_DEFINITION FirstCounter( PPERF_OBJECT_TYPE PerfObj )
{
	return ( (PPERF_COUNTER_DEFINITION)((PBYTE)PerfObj + PerfObj->HeaderLength) );
}

PPERF_COUNTER_DEFINITION NextCounter( PPERF_COUNTER_DEFINITION PerfCntr)
{
	return ( (PPERF_COUNTER_DEFINITION)((PBYTE)PerfCntr + PerfCntr->ByteLength)  );
}
void Initialize()
{
	TCHAR* pCurrentString; // pointer for enumerating data strings
	DWORD dwCounter; // current counter index
	DWORD dwBufferSize;
	
	dwCounter = GetNumOfCounters();
	pCounterNames = (TCHAR**)malloc(sizeof(TCHAR*)*dwCounter);
	pCounterIDs = (TCHAR**)malloc(sizeof(TCHAR*)*dwCounter);
// load compounded counter string.
	dwBufferSize = 8192;
	pStrbuf = (TCHAR*)malloc(dwBufferSize);
	
	while ( RegQueryValueEx(HKEY_PERFORMANCE_DATA,
			TEXT("Counter"),
			NULL,
			NULL,
			(LPBYTE)pStrbuf,
			&dwBufferSize) == ERROR_MORE_DATA)
	{
		dwBufferSize += 1024;
		pStrbuf = (TCHAR*)realloc(pStrbuf, dwBufferSize);
	}	
	
	dwTotalTrack = 0;
	
	for( pCurrentString = pStrbuf; *pCurrentString;
	pCurrentString += (lstrlen((LPCTSTR)pCurrentString)+1) )
	{
		dwCounter = _ttoi(pCurrentString);
		dwTracks[dwTotalTrack++] = dwCounter;
		pCounterIDs[dwCounter] = pCurrentString;
		pCurrentString += (lstrlen((LPCTSTR)pCurrentString)+1);
		pCounterNames[dwCounter] = pCurrentString;
	}
}

void MakeCounterID(TCHAR* pCounter, TCHAR* pID)
{
	int i;
	for (i=0; i<dwTotalTrack; i++)
	if (CompareString(LOCALE_SYSTEM_DEFAULT, 0,
	pCounter, -1, pCounterNames[dwTracks[i]], -1) == CSTR_EQUAL)
	{
		_tcscpy(pID, pCounterIDs[dwTracks[i]]);
		break;
	}
}
void Uninitialize()
{
	free(pStrbuf);
}
DWORD QueryPerformanceData(TCHAR* pObject, TCHAR* pInst, TCHAR* pCounter, __int64* res)
{
	PPERF_DATA_BLOCK PerfData = NULL;
	PPERF_OBJECT_TYPE PerfObj;
	PPERF_INSTANCE_DEFINITION PerfInst;
	PPERF_COUNTER_DEFINITION PerfCntr, CurCntr;
	PPERF_COUNTER_BLOCK PtrToCntr;
	DWORD i, j, k;
	DWORD dwBufferSize;
	TCHAR* pStr;
// Allocate the buffer for the performance data.
	dwBufferSize = 8192;
	PerfData = (PPERF_DATA_BLOCK) malloc( dwBufferSize );

	while( RegQueryValueEx( HKEY_PERFORMANCE_DATA,
	pObject, // TEXT("Global")
	NULL,
	NULL,
	(LPBYTE)PerfData,
	&dwBufferSize ) == ERROR_MORE_DATA )
	{
		dwBufferSize += 1024;
		PerfData = (PPERF_DATA_BLOCK) realloc( PerfData, dwBufferSize );
	}
	// save the high-resolution frequency
	freq = PerfData->PerfFreq.QuadPart;
	// Get the first object type.
	PerfObj = FirstObject( PerfData );
	// Process all objects.

	for( i=0; i < PerfData->NumObjectTypes; i++ )
	{
	// Display the object by index and name.
		_tprintf( TEXT("\nObject %ld: %s\n"), PerfObj->ObjectNameTitleIndex,
		pCounterNames[PerfObj->ObjectNameTitleIndex] );
		// Get the first counter.
		PerfCntr = FirstCounter( PerfObj );
		if( PerfObj->NumInstances > 0 )
		{
			// Get the first instance.
			PerfInst = FirstInstance( PerfObj );
			// Retrieve all instances.
			for( k=0; k < PerfObj->NumInstances; k++ )
			{
				// indicate the instance name.
				pStr = (TCHAR*)((PBYTE)PerfInst + PerfInst->NameOffset);
				
				if (CompareString(LOCALE_SYSTEM_DEFAULT, 0,
				pInst, -1, pStr, -1) != CSTR_EQUAL)
				{
					PerfInst = NextInstance( PerfInst );
					continue;
				}
				// Display the instance by name.
				_tprintf( TEXT("\n\tInstance %s: \n"), pStr);
				CurCntr = PerfCntr;
				PtrToCntr = (PPERF_COUNTER_BLOCK) ((PBYTE)PerfInst + PerfInst->ByteLength );
				// Retrieve all counters.
				
				for( j=0; j < PerfObj->NumCounters; j++ )
				{
					if ((CurCntr->CounterType & PERF_DISPLAY_NOSHOW) == PERF_DISPLAY_NOSHOW)
					{
						CurCntr = NextCounter( CurCntr );
						continue;
					}
						// indicate the counter name.
					pStr = pCounterNames[CurCntr->CounterNameTitleIndex];
					
					if (CompareString(LOCALE_SYSTEM_DEFAULT, 0, pCounter, -1, pStr, -1) != CSTR_EQUAL)
					{
						CurCntr = NextCounter( CurCntr );
						continue;
					}
					// Display the counter by index and name.
					_tprintf(TEXT("\t\tCounter %ld: %s\n"), CurCntr->CounterNameTitleIndex, pStr);
				
					if ((CurCntr->CounterType & PERF_100NSEC_TIMER_INV) == PERF_100NSEC_TIMER_INV)
					{
						*res = *(__int64*)((char*)PtrToCntr + CurCntr->CounterOffset);
						return PERF_100NSEC_TIMER_INV;
					}
					// Get the next counter.
					CurCntr = NextCounter( CurCntr );
				}
				// Get the next instance.
				PerfInst = NextInstance( PerfInst );
			}
		}
		else
		{
			// Get the counter block.
			PtrToCntr = (PPERF_COUNTER_BLOCK) ((PBYTE)PerfObj + PerfObj->DefinitionLength );
			// Retrieve all counters.
			for( j=0; j < PerfObj->NumCounters; j++ )
			{
				if ((PerfCntr->CounterType & PERF_DISPLAY_NOSHOW) == PERF_DISPLAY_NOSHOW)
				{
					PerfCntr = NextCounter( PerfCntr );
					continue;
				}
				// indicate the counter name.
				pStr = pCounterNames[PerfCntr->CounterNameTitleIndex];
				
				if (CompareString(LOCALE_SYSTEM_DEFAULT, 0, pCounter, -1, pStr, -1) != CSTR_EQUAL)
				{
					PerfCntr = NextCounter( PerfCntr );
					continue;
				}
				// Display the counter by index and name.
				_tprintf(TEXT("\t\tCounter %ld: %s\n"),
				PerfCntr->CounterNameTitleIndex, pStr);
				
				if (PerfCntr->CounterType == PERF_100NSEC_TIMER_INV)
				{
					*res = *(__int64*)((char*)PtrToCntr + PerfCntr->CounterOffset);
					return PERF_100NSEC_TIMER_INV;
				}
				// Get the next counter.
				PerfCntr = NextCounter( PerfCntr );
			}
		}
		// Get the next object type.
		PerfObj = NextObject( PerfObj );
	}//for
}
void main()
{
	TCHAR pIndexName[20];
	__int64 st, res;
	DWORD type;
	
	Initialize();
	
	MakeCounterID(TEXT("Processor"), pIndexName);
	while (1)
	{
		Sleep(1000);
		type = QueryPerformanceData(pIndexName, TEXT("0"), TEXT("% Processor Time"), &st);
		
		if (type == PERF_100NSEC_TIMER_INV)
		{
			static __int64 last = st;
			res = 100 - (__int64)((float)(st - last) / 10000000.0f * 100.0f);
			last = st;
		}
		_tprintf(TEXT("[ CPU Load : %I64u ]\n"), res);
	}
	Uninitialize();
}


